package VRML;

import java.util.*;
import java.io.*;
import java.net.*;

/** This is the VRML parser for Ht:dig */
public class htdigvrml extends vrmlInt
{
// holds the url of the world
private URL urlat;
private String delimiters = " -\t,;.\\[]{}():?><#@!$%^&*+=~|\r\n";

/**What should be done with a Anchor node
@param A StringTokeniser which holds the remark string less the Anchor comment*/
public  void indexAnchor(String st ,  String description)
    {   
    try{
	URL newurl = new URL(urlat,st);
	// also index the description
	if(description.length()>0)
	    {
	    StringTokenizer sp = new StringTokenizer(description, delimiters);
	    // tokenise the string and use it	
	    while( sp.hasMoreTokens())
		{
		String word = sp.nextToken();
		if(word.length()>=3)
		    {
		    //index it with a weight of the body
		    System.out.println("w\t"+word+"\t0\t0");
		    }
		}  
	    }
	else
	    {
	    description = "VRML file";
	    }    
	 // need to make sure that they are not the same url
	if(!urlat.sameFile(newurl))
	    {
	    // not the same file pass to htdig for indexing
	    System.out.println("u\t"+newurl.toString()+"\t"+description);	
	    }
	}
    catch( MalformedURLException e )
	{
	// we can't form the URL give up and go home!    
	}
    }

/**What the should done with a Text node 
@param A StringTokeniser which holds the text string less the Text comment*/
public  void indexText(String st)
    {
    StringTokenizer sp = new StringTokenizer(st, delimiters);
    // tokenise the string and use it	
    while( sp.hasMoreTokens())
	{
	String word = sp.nextToken();
	if(word.length()>=3)
	    {
	    //index it with a weight of the body
	    System.out.println("w\t"+word+"\t0\t0");
	    }
	}  
    }

/**What the item should do for a Viewpoint node
@param A StringTokeniser which holds the viewpoint string less the viewpoint comment*/
public  void indexViewpoint(String st)
    {
    StringTokenizer sp = new StringTokenizer(st, delimiters);
    // tokenise the string and use it	
    while( sp.hasMoreTokens())
	{
	String word = sp.nextToken();
	if(word.length()>=3)
	    {
	    //index it with a weight of the body
	    System.out.println("w\t"+word+"\t0\t0");
	    }
	}  	
    }

/**What the item should do for a WorldInfo node
@param A StringTokeniser which holds the wordinfo string less the wordinfo comment*/
public  void indexWorldinfo(String st)
    {
    StringTokenizer sp = new StringTokenizer(st, delimiters);
    // tokenise the string and use it	
    while( sp.hasMoreTokens())
	{
	String word = sp.nextToken();
	if(word.length()>=3)
	    {
	    //index it with a weight of the body
	    System.out.println("w\t"+word+"\t0\t0");
	    }
	}  	
    }


/**main control loop which runs the parser

 */

public void doit()
    {
    while(parser.ok)
	{
	parser.vrmlRead();    
	}
    // HTdig has to have an excert therfoe make one up
    System.out.println("h\t This is a vrml file need to use the correct "+
    "plugin to view");	
    }
    
public htdigvrml(String in,  String urlat)
    {
    super(in);
    try{
	this.urlat= new URL(urlat);
	}
    catch( MalformedURLException e )
	{}
    
    }

}
