/**This is a simple vrml parser that is designed to be used with HTdig
and Jobjects using the relevant interface. 
*/

package VRML;

import java.io.*;
import java.util.*;
import java.lang.Integer;
import java.util.zip.GZIPInputStream;
import java.io.StreamTokenizer;

class vrml {

public boolean ok = true;
private BufferedReader fileinput;
private vrmlInt type;

/** The method to read the pdb file
@param input - The pdb file to parse
@param type  - The program vrml int type interfacing too
*/

vrml(File input, vrmlInt type)
    {
    fileinput = this.getReader(input);
    // make sure type is not null	
   
    if(type!=null)
	this.type = type;
    else
	System.exit(1);
    }

/**Reads the VRML file and parses the contents
*/
public void vrmlRead()
    {
    if(fileinput!=null)
	{
	try{
	// shows if the verison of VRML is 1 or 2
	// true = VRML2/97 false = VRML1
	   boolean VRMLVersion = true;
	   boolean first = true;
	   
	   
	   String line = fileinput.readLine();
	   if(line!=null)
	    {
	    if(first)
		{
		if(line.toUpperCase().startsWith("#VRML V2.0 UTF8"))
		    {
		    // set the type
		    //System.out.println("Here1"+line);
		    VRMLVersion = true;	
		    }
		else
		    {
		    if(line.equalsIgnoreCase("#VRML V1.0 ascii"))	
			{
			 VRMLVersion = false;	
			}
		    else 
			{
			//it is buggered 
			ok = false;    
			}
		    }
			
		first= false; 
		//System.out.println("Here"+first+VRMLVersion);   
		}
	   
		// now know the version that we are using
		if(VRMLVersion)
		    {
		    //uses the buffered file reader fileinput
		    VRML_two();		     
		    }
		else
		    {
		    VRML_one();
		    }
		  
		    /*
		    StringTokenizer st = new StringTokenizer(line);
		    String start_of_line = st.nextToken();*/
	    }
	    else
		{
		this.ok = false;    
		}
	}
	catch( NoSuchElementException err)
	    {
	    // end of line just give up and go on to the next one	
	    this.ok=false;
	    }
	catch(IOException e)
	    {
	    System.err.println("An Disk Error Occurred");
	    ok = false;
	    }     
	}
    
    }
       
private void VRML_two() throws IOException, NoSuchElementException
    {
    // VRML97 nodes we want are 
    // Anchor
    // text
    // viewpoint
    // Worldinfo
    // make a stream tokenisor
    //System.out.println("Here VRML_Two");
    StreamTokenizer input = new StreamTokenizer(fileinput);
    input.eolIsSignificant(true);
     input.commentChar('#');
    while(input.nextToken()!=StreamTokenizer.TT_EOF)
	{
	// this switch could be relaced by an if probably 
	switch(input.ttype)
	    {
	    case input.TT_WORD:
		{
		// need to check the word 
		if(input.sval.equalsIgnoreCase("Worldinfo"))
		    {
		    //System.out.println("WIType "+input.ttype +" Word "+input.sval);
		    // need to look for info and title	    
		    String information =  new String();
		    int braketpair = 0;
		    while(true)
			    {
			    
			    input.nextToken();
			    switch(input.ttype)
				{
				case input.TT_WORD:
				    {
				    if(input.sval.equalsIgnoreCase("info"))
					{
					// want the next string 
					//input.nextToken();
					information +=getString(input);
					//input.sval+" ";										    
					}
				    // may not have a world info 
				    if(input.sval!=null)
					{
				    if(input.sval.equalsIgnoreCase("title"))
					{
					//input.nextToken();
					information+= getString(input);
					//input.sval+" ";
					}}	    
				    break;
				    }
				// other wise count the pairs of curly brakets {}
				case '}':
				    {
				    braketpair--;
				    break;	
				    }
				case '{':
				    {
				    braketpair++;
				    break;
				    }
				case input.TT_EOF:
				    {
				    // reached the end of the stream just get out of the while loop
				    braketpair=0;
				    break;	
				    }
				}
			    if(braketpair<=0)
				{
				if(information.length()>0)
				    {
				    type.indexWorldinfo(information);
				    }
				break;
				}
			    }					
			//end of world info part
		    }
		else
		    {
		    if(input.sval.equalsIgnoreCase("Anchor"))	
			{
			// need to find URL 
			int braketpair = 0;
			String nexturl = null;
			String Description = null;
			while(true)
			    {
			    input.nextToken();
			    switch(input.ttype)
				{
				case input.TT_WORD:
				    {
				    if(input.sval.equalsIgnoreCase("url"))
					{
					// want the next string 
					input.nextToken();
					nexturl = input.sval;
					// might have a cross hatch at start or end
					//remove the one at the start if not relative ie doesnot have a /
					int index = nexturl.indexOf("/");
					// have to check to see if it could be realtive or embeded
					if(index!=-1)
					    {
					    if(nexturl.startsWith("#"))
						{
						nexturl = nexturl.substring(1,nexturl.length());  	
						}
					    }
					if(nexturl.endsWith("#"))
					    {
					     nexturl = nexturl.substring(0,nexturl.length()-1);
					    }													    
					}
				    if(input.sval.equalsIgnoreCase("Description"))
					{
					input.nextToken();
					Description = new String(input.sval);
					}	    
				    break;
				    }
				// other wise count the pairs of curly brakets {}
				case '}':
				    {
				    braketpair--;
				    break;	
				    }
				case '{':
				    {
				    braketpair++;
				    break;
				    }
				case input.TT_EOF:
				    {
				    // reached the end of the stream just get out of the while loop
				    braketpair=0;
				    break;	
				    }
				}
			    if(braketpair<=0)
				{
				if(nexturl!=null&&Description!=null)
				    {
				    type.indexAnchor(nexturl,  Description);
				    }
				//System.out.println("Brakets Paired");
				break;
				}
			    }					
			//end of anchor part
			}
		    else
			{
			if(input.sval.equalsIgnoreCase("text")||input.sval.equalsIgnoreCase("CoTextGraph"))
			    {
			    // field we wnat here is called string
			   // System.out.println("TEType "+input.ttype +" Word "+input.sval);
			    String information =  new String();
			    int braketpair = 0;
			    while(true)
				{
				input.nextToken();
				switch(input.ttype)
				    {
				    case input.TT_WORD:
					{
					if(input.sval.equalsIgnoreCase("string"))
					    {
					    // want the next string 
					   //input.nextToken();
					    information += getString(input);
					    //+=input.sval+" ";										    
					    }
				    	break;
					}
				    // other wise count the pairs of curly brakets {}
				    case '}':
					{
					braketpair--;
					break;	
					}
				    case '{':
					{
					braketpair++;
					break;
					}
				    case input.TT_EOF:
					{
					// reached the end of the stream just get out of the while loop
					braketpair=0;
					break;	
					}
				    }
				if(braketpair==0)
				    {
				    if(information.length()>0)
					{
					type.indexText(information);
					}
				   // System.out.println("Brakets Paired");
				    break;
				    }
				}					
			//end of text part
			    
			    }
			else
			    {
			    if(input.sval.equalsIgnoreCase("viewpoint"))
				{
				//System.out.println("VIType "+input.ttype +" Word "+input.sval);    
				// field we wnat here is called description
				String information =  new String();
				int braketpair = 0;
				while(true)
				    {
				    input.nextToken();
				    switch(input.ttype)
					{
					case input.TT_WORD:
					    {
					    if(input.sval.equalsIgnoreCase("description"))
						{
						// want the next string 
						// input.nextToken();
						information += getString(input);
						// input.sval+" ";										    
						}
				    	    break;
					    }
					// other wise count the pairs of curly brakets {}
					case '}':
					    {
					    braketpair--;
					    break;	
					    }
					case '{':
					    {
					    braketpair++;
					    break;
					    }
					case input.TT_EOF:
					    {
					    // reached the end of the stream just get out of the while loop
					    braketpair=0;
					    break;	
					    }
					}
				    if(braketpair<=0)
					{
					if(information.length()>0)
					    {
					    type.indexViewpoint(information);
					    }
					//System.out.println("Brakets Paired");
					break;
					}
				    }					
				//end of viewpoint part
				}	
			    }
			}
		    }
	    	break;
		}
		default:
		break;		

	    }		
//End of while
	}
// end of read VRML_two
    } 

private void VRML_one() throws IOException, NoSuchElementException
    {
    // VRML 1.0 nodes are
    // Info - string
    // AsciiText - string 
    // WWWAnchor - name 
    // WWWInline  - name
    // there node can be split into two groups the anchors and the text/info 
    // make a stream tokenisor
    StreamTokenizer input = new StreamTokenizer(fileinput);
    // tell it # marks a comment - will ignore to the end of the line
    input.commentChar('#');
    input.quoteChar('"');
    input.eolIsSignificant(true); 
    while(input.nextToken()!=StreamTokenizer.TT_EOF)
	{
	// this switch could be relaced by an if probably 
	switch(input.ttype)
	    {
	    case input.TT_WORD:
		{
		// need to check the word 
		if(input.sval.equalsIgnoreCase("info")||input.sval.equalsIgnoreCase("AsciiText"))
		    {
		   // System.out.println("V1.0 WType "+input.ttype +" Word "+input.sval);
		    // need to look for info and title	    
		    String information =  new String();
		    int braketpair = 0;
		    while(true)
			    {
			    
			    input.nextToken();
			    switch(input.ttype)
				{
				case input.TT_WORD:
				    {
				    if(input.sval.equalsIgnoreCase("string"))
					{
					//System.out.println(input.sval);
					//input.nextToken();
					//System.out.println(input.sval);
					//information +=input.sval+" ";	
					// call get string cos toekn isor can't do what we need
					// comments may be across multtiply line which is annoying									    
					information = getString(input);    
					} 
				    break;
				    }
				// other wise count the pairs of curly brakets {}
				case '}':
				    {
				    braketpair--;
				    break;	
				    }
				case '{':
				    {
				    braketpair++;
				    break;
				    }
				case input.TT_EOF:
				    {
				    // reached the end of the stream just get out of the while loop
				    braketpair=0;
				    break;	
				    }
				}
			    if(braketpair<=0)
				{
				if(information.length()>0)
				    {
				    type.indexWorldinfo(information);
				    }
				break;
				}
			    }					
			//end of info part
		    }
		else
		    {
		    if(input.sval.equalsIgnoreCase("WWWAnchor")||input.sval.equalsIgnoreCase("WWWInline"))	
			{
			// need to find URL 
			int braketpair = 0;
			String nexturl = null;
			String Description = null;
			while(true)
			    {
			    input.nextToken();
			    switch(input.ttype)
				{
				case input.TT_WORD:
				    {
				    if(input.sval.equalsIgnoreCase("name"))
					{
					// want the next string 
					input.nextToken();
					nexturl = input.sval;
					// might have a cross hatch at start or end
					//remove the one at the start if not relative ie doesnot have a /
					int index = nexturl.indexOf("/");
					// have to check to see if it could be realtive or embeded
					if(index!=-1)
					    {
					    if(nexturl.startsWith("#"))
						{
						nexturl = nexturl.substring(1,nexturl.length());  	
						}
					    }
					if(nexturl.endsWith("#"))
					    {
					     nexturl = nexturl.substring(0,nexturl.length()-1);
					    }													    
					}
				    if(input.sval.equalsIgnoreCase("Description"))
					{
					input.nextToken();
					Description = new String(input.sval);
					}	    
				    break;
				    }
				// other wise count the pairs of curly brakets {}
				case '}':
				    {
				    braketpair--;
				    break;	
				    }
				case '{':
				    {
				    braketpair++;
				    break;
				    }
				case input.TT_EOF:
				    {
				    // reached the end of the stream just get out of the while loop
				    braketpair=0;
				    break;	
				    }
				}
			    if(braketpair<=0)
				{
				if(nexturl!=null&&Description!=null)
				    {
				    type.indexAnchor(nexturl,  Description);
				    }
				//System.out.println("Brakets Paired");
				break;
				}
			    }					
			//end of anchor part
			}
		    }
	    	break;
		}
		default:
		break;		
	    }		
//End of while
	}
    
    }

/**Returns a string that is the complete string between "" makes even if it spans mutilply lines */
private String getString(StreamTokenizer input) throws IOException
    {
   // input.eolIsSignificant(true);
    String str = new String();
    // have to check what the next token is
    while(true)
	{
	input.nextToken();
	if(input.ttype==input.TT_WORD||input.ttype=='"')
	    {
	    //System.out.println("Token "+input.sval +input.ttype);
	    str +=input.sval+" ";
	    }
	else
	    {
	    break;
	    }    
	}
   // input.eolIsSignificant(false);
    return str;
    }
    
// get an input steam attached to the file
private BufferedReader getReader(File file1)
    {
    // open the file
    BufferedReader filein;
    if(!file1.exists())
	    {
	    System.err.println("File "+file1.getName() +" does not exist");
	    this.ok = false;
	    }
    else
	  {
	  if(!file1.canRead())
	    {
	    System.err.println("cannot read this file "+file1.getName());
	    }
    else
	    {
	    if(file1.isDirectory())
		    {
		    System.err.println("This is a directory "+file1.getName());
		    }
	    else
		    {
		    try {
		    // pdb can be compressed assume it is as 
		    // if thows an error try an uncompessed stream
			filein= new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(file1))));
			return filein;
				
			}
			/*catch(IOException e)
			    {
			    System.err.println("An error occured reading the vrml file");
			    ok = false;
			    }*/
			catch (SecurityException e) {
			    System.err.println("Security Exception displaying HTML:"+e.getMessage());
			    } 
			catch (IOException e) 
			    {
			    // if this error is thrown may be because not compressed
			    if(e.getMessage().equalsIgnoreCase("Not in GZIP format"))
				{
				//then try normal text and can do some thing with it
				try {
				  
				    filein = new BufferedReader(new FileReader(file1));
				    return filein;
				    }
				    catch(IOException err)
					{
					
					System.err.println("IO Exception displaying HTML(N):"+err.getMessage());
					// give up must be something else
					ok= false;         
					}
				}
			    else
				{
				System.err.println("IO Exception displaying HTML:"+e.getMessage());
				ok = false;
				}
			    }
		   }
	    }	
	}
  
    return null;	
   
  }
}
