package chemical;

import java.io.*;
import java.util.*;
import VRML.*;
import java.lang.String;
import java.lang.Integer;

/** This is the front to the extrnal parser for Ht://dig - see www.htdig.org
*/
class Htdigfront{

/**simple driver */
public static void main(String[] args)
    {
    try{
    boolean log = true;
    File logfile = new File("jo");
    int[] times = new int[3];
    // create / load a temp file so we can log how many of each file type we have done
    if(log)
	{
	 logfile = new File("chemical_parse.log");
	if(logfile.exists())
	    {
	    // read in the content
	    BufferedReader gotit= new BufferedReader(new FileReader(logfile));
	    if(logfile.canRead())
		{
		while(true)
		    {
		    String line = gotit.readLine();
		    if(line==null)
			{
			break;    
			}
		    if(line.startsWith("pdb"))
			{
			times[0]=Integer.parseInt(line.substring(4).trim());    
			}
		    else
			{
			if(line.startsWith("dx"))
			    {
			    times[1]=Integer.parseInt(line.substring(3).trim());     
			    }
			else
			    {
			    if(line.startsWith("vrml"))
				{
				 times[2]=Integer.parseInt(line.substring(5).trim());   
				}
			    }    
			}
		    }
		}	
	    }
	else
	    {
	    //assume that it wasn't and ignore it
	    
	    times[0]=0;
	    times[1]=0;
	    times[2]=0;	
	    }
	     	
	}
	
    if(args.length>=2)
	{
	// determine the type:
	if(args[1].equalsIgnoreCase("chemical/x-pdb"))
	    {
	    // pdb can be gziped need to check and if it is unzip it
	    
	    Htdigpdb joop = new Htdigpdb(args[0]);	
	    joop.doit();
	    if(log) 
	    times[0]++;	
	    }
	else
	    {
	    if(args[1].equalsIgnoreCase("chemical/x-jcamp-dx"))
		{
		Htdigdx joop = new Htdigdx(args[0]);
		joop.doit();
		if(log) 
		times[1]++;    
		}
	    else
		{
		if(args[1].equalsIgnoreCase("x-world/x-vrml")||
		args[1].equalsIgnoreCase("model/x-vrml"))
		    {
		    htdigvrml joop = new htdigvrml(args[0], args[2]);
		    joop.doit();
		    if(log) 
		    times[2]++;   
		    }   
		}
	    }
	// write out the log
	if(log)
	    {
	    FileWriter logging = new FileWriter(logfile);
	    logging.write("pdb  "+times[0]+"\ndx  "+times[1]+"\nvrml "+times[2]+"\n");
	    logging.flush();
	    }
	}
    else 
	{
	System.err.println("Must put file");    
	}
    }
    catch(FileNotFoundException e )
	{
	// bugger it - only the log file causing problems
	System.err.println("E log problem");    
	}
     
     catch(IOException e)
	{
	// bugger it - only the log file causing problems
	System.err.println("I log problem");    
	}
     catch( NumberFormatException e)
	{
	// bugger it - only the log file causing problems
	System.err.println("N log problem");    
	}

    }
        
}
