package chemical;

import java.io.*;
import java.util.*;
import java.lang.String;

/** This is the front to the pdb parser for Ht://dig - see www.htdig.org
*/
class Htdigpdb extends pdbInt{
/** Constructor
 */
private int wordcount = 0;
Htdigpdb(String name)
    {
    super(name);
    }   
 
// HT dig wants the info back on stdio therefore just use system.out
public void doit()
    {
    while(parser.ok)
	{
	parser.pdbRead();    
	}
    // HTdig has to have an excert therfoe make one up
    System.out.println("h\t This is a pdb file need to use the correct "+
    "plugin to view");
    }
/**What the item should do for a Remark comment 
@param A StringTokeniser which holds the remark string less the remark comment*/
public void indexRemark(StringTokenizer st)
	{
	while (st.hasMoreTokens()) 
	    {
	    String blob = rep(checkString(st.nextToken()));
	    if(blob.length()>3)
		{
		System.out.println("w\t"+blob+"\t0\t0\t");
		}
	    }
	}


/**What the item should do for a AUTHOR comment 
@param A StringTokeniser which holds the remark string less the AUTHOR comment*/
public void indexAuthor(StringTokenizer st)
	{
	//System.out.print("m\tDC.Author\t");
	// make a string
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    String word =st.nextToken(); 
	    String current = checkString(word);
            word = rep(current);
	    if(word.length()>3)
		{
		// if not equal must have a period or comma therefore need to find out and
		// substring the componets
		if(word.equals(current))
		    {
		    System.out.println("w\t"+word+"\t0\t0");
		    }
		else
		    {
		    // do it recusively!
		    indexAuthor(new StringTokenizer(word));  	
		    }
		}
	    }
	}

/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public void indexTitle(StringTokenizer st)
	{
	
	// make a string
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as htdig does not search titles
            String current = rep(checkString(st.nextToken()));
	    out+=current+" ";
	    System.out.println("w\t"+current+"\t0\t1\t");
	    }
	 System.out.print("t\t"+out+"\n");
	}
	

/**What the item should do for a Journal comment 
@param A StringTokeniser which holds the remark string less the JRNL comment*/
public void indexJrnl(StringTokenizer st)
	{
	int a = 0 ;
	}

/**What the item should do for a keywords comment 
@param A StringTokeniser which holds the remark string less the KEYWRD comment*/
public void indexKeywds(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	    {
            String blob = rep(checkString(st.nextToken()));
            System.out.println("w\t"+blob+"\t0\t5");
	    }	
    }

/**What the item should do for a EXPermental  comment 
@param A StringTokeniser which holds the remark string less the EXPDTA comment*/
public void indexExpdta(StringTokenizer st)
    {
    int a = 1;
    }

/**What the item should do for a compound  comment 
@param A StringTokeniser which holds the remark string less the compound comment*/    
public void indexCompnd(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	    {
            String word =st.nextToken(); 
	    String current = checkString(word);
            word = rep(current);
	    if(word.length()>=3)
		{
		// if not equal must have a period or comma therefore need to find out and
		// substring the componets
		if(word.equals(current))
		    {
		    System.out.println("w\t"+word+"\t0\t0");
		    }
		else
		    {
		    // do it recusively!
		    indexAuthor(new StringTokenizer(word));  	
		    }
		}            
	    }		
    }
    
private String checkString(String in )
    {
    // make sure that the word only has letters or numbers
    // at the ends as otherwise this causes problems
    // First start at front:
    while(true)
	{
	try{
	char ab = in.charAt(0);
	   if(!Character.isLetterOrDigit(ab))
		{
		// remove it	
		in = in.substring(1);
		}
	   else
		{
		break;	
		}
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // check the tail
    while(true)
	{
	try{
	char ab = in.charAt(in.length()-1);
	   if(!Character.isLetterOrDigit(ab))
	    {
	    // remove it	
	    int place = in.length()-1;
	    in = in.substring(0, place);  
	    }
	   else
	    {
	    break;	
	    }
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // make sure that there are no periods or commas replace with space
    return in;
    }

/**Replaces ',' and '.' in a string with spaces */
private String rep(String in)
    {      
    String blob = in.replace('.',' ');
    in = blob.replace(',',' ');	 
    return in;
    }       
}
