/**This is a simple JCAMP dx parser that is designed to be used with HTdig
and Jobjects using the relevant interface. 
*/

package chemical;

import java.io.*;
import java.util.*;


class dx {

public boolean ok = true;
private BufferedReader fileinput;
private int line_number = 0;
// shows the program interfacing to
private dxInt type ; 
/** The method to read the dx file
@param dx - The pdb file to parse
@param type  - The program interfacing too
*/

dx(File input, dxInt type)
    {
    fileinput = this.getReader(input);
    // make sure type is not null	
    if(type!=null)
	this.type = type;
    else
	System.exit(0);
    }

/**Reads the pdb file and parses the contents
*/
public void dxRead()
    {
    if(fileinput!=null)
	{
	try{
	    // Lines we want to index start with
	    // ##TITLE
	    // ##OWNER
	    // ##DATA TYPE
	    
	   // read in a line and see what it starts with 
	   String line = fileinput.readLine();
	   // might need a line counter
	   //System.out.println(line);
	   if(line!=null)
	   {
	   line_number++; 
	   // tokenise the line so that we can test without worry about case
	   StringTokenizer st = new StringTokenizer(line);
	   String start_of_line = st.nextToken();
	   //System.out.println(start_of_line);
	   if(start_of_line.equalsIgnoreCase("##TITLE="))
		{
		 type.indexTitle(st);
		}
	    else
		{
		if(start_of_line.equalsIgnoreCase("##OWNER="))
		    {
		    type.indexOwner(st);
		    }    
		else
		    {
		    if(start_of_line.equalsIgnoreCase("##DATA"))
			{
			// make sure the next is TYPE otherwise ignore
			if(st.nextToken().equalsIgnoreCase("TYPE="))
			    {
			    type.indexType(st);    
			    }
			}
		    
		    }
		}
	   }
	  else
	    {
	    this.ok = false;    
	    }
	}
	catch( NoSuchElementException err)
	    {
	    // end of line just give up and go on to the next one	
	    this.ok=false;
	    }
	catch(IOException e)
	    {
	    System.err.println("An Disk Error Occurred");
	    ok = false;
	    }     
	}
    
    }   
     

// get an input steam attached to the file
private BufferedReader getReader(File file1)
    {
    // open the file
    BufferedReader filein;
    boolean ok=true;
    if(!file1.exists())
	    {
	    System.err.println("File "+file1.getName() +" does not exist");
	    ok = false;
	    }
    else
	  {
	  if(!file1.canRead())
	    {
	    System.err.println("cannot read this file "+file1.getName());
	    }
    else
	    {
	    if(file1.isDirectory())
		    {
		    System.err.println("This is a directory "+file1.getName());
		    }
	    else
		    {
		    try {
			filein = new BufferedReader(new FileReader(file1));
			return filein;
			}
			catch(IOException e)
			{
			System.err.println("An error occured reading the schema file");
			ok = false;
			}
         
		    }
	    }	
	}
  
    return null;	
   
  }
}
