/**This is a simple Pdb parser that is designed to be used with HTdig
and Jobjects using the relevant interface. 
*/

package chemical;

import java.io.*;
import java.util.*;
import java.lang.Integer;
import java.util.zip.GZIPInputStream;


class pdb {
// interface ints for different search engines 
public boolean ok = true;
private BufferedReader fileinput;
private int line_number = 0;
// shows the program interfacing to
private pdbInt type ; 
/** The method to read the pdb file
@param input - The pdb file to parse
@param type  - The program interfacing too
*/

pdb(File input, pdbInt type)
    {
    fileinput = this.getReader(input);
    // make sure type is not null	
   
    if(type!=null)
	this.type = type;
    else
	System.exit(1);
    }

/**Reads the pdb file and parses the contents
*/
public void pdbRead()
    {
    if(fileinput!=null)
	{
	try{
	    // Lines we want to index start with
	    // REMARK
	    // TITLE
	    // AUTHOR
	    // JRNL
	    // KEYWDS
	    // EXPDTA
	    //COMPND
	    // Others can be added
	    
	   // read in a line and see what it starts with 
	   String line = fileinput.readLine();
	   // might need a line counter
	   
	   if(line!=null)
	   {
	   line_number++; 
	   // tokenise the line so that we can test without worry about case
	   StringTokenizer st = new StringTokenizer(line);
	   String start_of_line = st.nextToken();
	   if(start_of_line.equalsIgnoreCase("REMARK"))
		{
		// Do what ever with the line depending on program
		// next token should be a number - discard
		try{
		    Integer blob = new Integer(st.nextToken().trim());
		    type.indexRemark(st);
		    }
		catch(NumberFormatException e)
		    {
		    // recreate the tokeniser
		    st = new StringTokenizer(line);
		    // remove the first token
		    start_of_line = st.nextToken();
		    // pass to handling function
		    type.indexRemark(st); 				     
		    }
		}
	    else
		{
		if(start_of_line.equalsIgnoreCase("AUTHOR"))
		    {
		    type.indexAuthor(st);
		    }    
		else
		    {
		    if(start_of_line.equalsIgnoreCase("TITLE"))
			{
			type.indexTitle(st);    
			}
		    else
			{
			if(start_of_line.equalsIgnoreCase("JRNL"))
			    {
			    type.indexJrnl(st);
			    }
			else
			    {
			    if(start_of_line.equalsIgnoreCase("KEYWDS"))
				{
				type.indexKeywds(st);    
				}
			    else
				{
				if(start_of_line.equalsIgnoreCase("EXPDTA"))
				    {
				    type.indexExpdta(st);	
				    }
				else
				    {
				    if(start_of_line.equalsIgnoreCase("COMPND"))
					{
					 type.indexCompnd(st);   
					}
				    }
				}	
			    }        
			}
		    }
		}
	   }
	  else
	    {
	    this.ok = false;    
	    }
	}
	catch( NoSuchElementException err)
	    {
	    // end of line just give up and go on to the next one	
	    this.ok=false;
	    }
	catch(IOException e)
	    {
	    System.err.println("An Disk Error Occurred");
	    ok = false;
	    }     
	}
    
    }   
     

// get an input steam attached to the file
private BufferedReader getReader(File file1)
    {
    // open the file
    BufferedReader filein;
    if(!file1.exists())
	    {
	    System.err.println("File "+file1.getName() +" does not exist");
	    this.ok = false;
	    }
    else
	  {
	  if(!file1.canRead())
	    {
	    System.err.println("cannot read this file "+file1.getName());
	    }
    else
	    {
	    if(file1.isDirectory())
		    {
		    System.err.println("This is a directory "+file1.getName());
		    }
	    else
		    {
		    try {
		    // pdb can be compressed assume it is as 
		    // if thows an error try an uncompessed stream
			filein= new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(file1))));
			return filein;
				
			}
			/*catch(IOException e)
			    {
			    System.err.println("An error occured reading the pdb file");
			    ok = false;
			    }*/
			catch (SecurityException e) {
			    System.err.println("Security Exception displaying HTML:"+e.getMessage());
			    } 
			catch (IOException e) 
			    {
			    // if this error is thrown may be because not compressed
			    if(e.getMessage().equalsIgnoreCase("Not in GZIP format"))
				{
				//then try normal text and can do some thing with it
				try {

				   // System.out.println("Here");
				    filein = new BufferedReader(new FileReader(file1));
				    return filein;
				    }
				    catch(IOException err)
					{
					
					System.err.println("IO Exception displaying HTML(N):"+err.getMessage());
					// give up must be something else
					ok= false;         
					}
				}
			    else
				{
				System.err.println("IO Exception displaying HTML:"+e.getMessage());
				ok = false;
				}
			    }
		   }
	    }	
	}
  
    return null;	
   
  }
}
