
package chemical;

import java.util.*;
import java.io.*;


/**This clas must be extended to create an interface for the pdb parser
All the functions must be over ridden as ever if they are a void
function:
 Will have to import 
 java.io.*;
 java.util.*;
*/
abstract class pdbInt
{
pdb parser;

/**What the item should do for a Remark comment 
@param A StringTokeniser which holds the remark string less the remark comment*/
public abstract void indexRemark(StringTokenizer st);

/**What the item should do for a AUTHOR comment 
@param A StringTokeniser which holds the remark string less the AUTHOR comment*/
public abstract void indexAuthor(StringTokenizer st);

/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public abstract void indexTitle(StringTokenizer st);

/**What the item should do for a Journal comment 
@param A StringTokeniser which holds the remark string less the JRNL comment*/
public abstract void indexJrnl(StringTokenizer st);

/**What the item should do for a keywords comment 
@param A StringTokeniser which holds the remark string less the KEYWRD comment*/
public abstract void indexKeywds(StringTokenizer st);

/**What the item should do for a EXPermental  comment 
@param A StringTokeniser which holds the remark string less the EXPDTA comment*/
public abstract void indexExpdta(StringTokenizer st);

/**What the item should do for aCompound  comment 
@param A StringTokeniser which holds the remark string less the Compound comment*/
public abstract void indexCompnd(StringTokenizer st);


/**main control loop which runs the parser
e.g.
public void doit()
    {
    while(parser.ok)
	{
	parser.pdbRead();    
	}
    }
 */

abstract void doit();

/**Consturctor should be called but may not  */	
pdbInt(String name)
    {
    // create the file
    File in = new File(name);
    // create the parser
    this.parser = new pdb(in,this);
    }
   

}
